# -*- coding: utf-8 -*-
## modellfensterElemente.py
## © Claus Albowski
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='3': from tkinter import *
else: from Tkinter import *

class CanvasElement(object):
    '''Alle Hauptelemente werden im Dictionary "nameUndElement" abgespeichert.
    Das Loeschen erfolgt dann ueber das tag.'''    

    @staticmethod
    def ObjektZuTag(tag):
        return CanvasElement.nameUndElement.get(tag)
    
    @staticmethod
    def NeuesElement(tag, element):
        return CanvasElement.nameUndElement.update({(tag,element)})

    @staticmethod
    def AendereNamen(zf, alterName, neuerName):
        '''ersetzt das Objekt mit dem bisherigen Namen
        durch eines mit dem neuen Namen;
        Problem: Auch die Fluesse und Wirkungen muessen
        gegebenenfalls angepasst werden.'''
        dasObjekt=CanvasElement.ObjektZuTag(alterName)
        typ=dasObjekt.__class__
        if typ in (BestandsElement,ParameterElement,ZwischengroesseElement):
            # Position sichern
            x,y=dasObjekt.GibPosition()        
        if typ in (BestandsElement,ParameterElement,ZwischengroesseElement):
            CanvasElement.LoescheElement(zf, dasObjekt)
            typ(zf, neuerName, (x,y))
            # Fluesse informieren & Wirkungen neu zeichnen
            for tag in CanvasElement.nameUndElement:
                element=CanvasElement.ObjektZuTag(tag)
                if element.__class__==FlussElement:
                    von,auf=element.GibVonAuf()
                    if alterName==von:
                        element.UpdateNamen(neuerName,auf)
                    elif alterName==auf:
                        element.UpdateNamen(von,neuerName)
                if element.__class__==WirkungElement:
                    if alterName==element.von:
                        auf=element.auf
                        CanvasElement.LoescheElement(zf, element)
                        WirkungElement(zf, neuerName, auf)
                    elif alterName==element.auf:
                        von=element.von
                        CanvasElement.LoescheElement(zf, element)
                        WirkungElement(zf, von, neuerName)
            return
        if typ in [FlussElement]:
            ## Flussdaten merken
            flussVon,flussAuf=dasObjekt.GibVonAuf()
            ## dann loeschen
            CanvasElement.LoescheElement(zf, dasObjekt)
            ## alle Wirkungen merken
            alteWirkungsTags=[]
            neueWirkungsTags=[]
            for tag in CanvasElement.nameUndElement:
                element=CanvasElement.ObjektZuTag(tag)
                if element.__class__==WirkungElement:
                    von,pfeil,auf=tag.partition('->')
                    if von==alterName:
                        alteWirkungsTags.append(tag)
                        neueWirkungsTags.append(neuerName+'->'+auf)
                    if auf==alterName:
                        alteWirkungsTags.append(tag)
                        neueWirkungsTags.append(von+'->'+neuerName)
            for tag in alteWirkungsTags: 
                CanvasElement.LoescheElement(zf, CanvasElement.ObjektZuTag(tag))
            FlussElement(zf, neuerName, flussVon, flussAuf)
            ## neue WirkungElemente einbauen
            for tag in neueWirkungsTags:
                von,pfeil,auf=tag.partition('->')
                WirkungElement(zf, von, auf)

    @staticmethod
    def LoescheElement(zf, element):
        tag=zf.gettags(element.ID)[0]
        if element.textID!=None:
            zf.delete(element.textID)
        CanvasElement.alleFigurenIDs.remove(element.ID)
        CanvasElement.nameUndElement.pop(tag)
        zf.delete(tag)

    @staticmethod
    def LoescheAlle(zf):
        alle=[]
        for tag in CanvasElement.nameUndElement:
            alle.append(CanvasElement.ObjektZuTag(tag))
        for element in alle:
            CanvasElement.LoescheElement(zf,element)
            
    @staticmethod
    def GibAlleFaktorNamenMitPosition():
        daten = []
        for tag in CanvasElement.nameUndElement:
            dasObjekt=CanvasElement.nameUndElement[tag]
            typ=dasObjekt.__class__
            if typ in (BestandsElement,ParameterElement,ZwischengroesseElement):
                # Position sichern
                x,y=dasObjekt.GibPosition()        
                daten.append((tag,x,y))
        return daten

    @staticmethod
    def IstFigurID(ID):
        return ID in CanvasElement.alleFigurenIDs
    
    @staticmethod
    def IstFigurTag(tag):
        return tag in CanvasElement.nameUndElement.keys()

    @staticmethod
    def AktualisiereWirkung(zf,von,auf):
        element=CanvasElement.ObjektZuTag(von+'->'+auf)
        CanvasElement.LoescheElement(zf,element)
        wi=WirkungElement(zf, von, auf)                            

    @staticmethod
    def AktualisiereFluss(zf,name):
        element=CanvasElement.ObjektZuTag(name)
        von,auf=element.GibVonAuf()
        CanvasElement.LoescheElement(zf,element)
        fl=FlussElement(zf, name, von, auf)
        
    
    nameUndElement=dict()
    alleFigurenIDs = []
    
    def __init__(self, zf, ID, pos, endPos, name=None):
        self.zf=zf
        self.ID=ID
        CanvasElement.alleFigurenIDs.append(ID)
        self.textID=None
        self.name=name
        self.x,self.y=pos
        self.xe,self.ye=endPos
        if name!=None:
            CanvasElement.NeuesElement(name,self)
            xm,ym=self.Mitte((self.x,self.y,self.xe,self.ye))
            if self.__class__ in (WirkungElement,FlussElement):
                xm,ym=xm+10,ym+10
            self.textID=zf.create_text(xm,ym, text=name, tag=name, font="Sans 11 bold")

    def GibID(self): return self.ID
    def GibTag(self): return name
    def GibPosition(self): return self.x,self.y
    def GibEndPosition(self): return self.xe,self.ye
    def BestimmeKoordinaten(self, pos, name):
        x,y=pos
        l=max(10+len(name)*11,60)
        xe,ye=pos[0]+l, pos[1]+30
        return x,y,xe,ye
    def Mitte(self, koordinaten):
        x,y,xe,ye=koordinaten
        return int((x+xe)/2),int((y+ye)/2)

class BestandsElement(CanvasElement):
    def __init__(self, zf, name, pos=(10,10)):
        '''zeichenflaeche und eindeutigen Namen uebergeben'''
        x,y,xe,ye=self.BestimmeKoordinaten(pos, name)
        ID=zf.create_rectangle(x,y, xe,ye, width=2, tag=name)
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
            
class ParameterElement(CanvasElement):
    def __init__(self, zf, name, pos=(10,10)):
        '''zeichenflaeche und eindeutigen Namen uebergeben'''
        x,y,xe,ye=self.BestimmeKoordinaten(pos, name)
        ID=zf.create_oval(x,y, xe,ye, tag=name, outline='#060', width=2)
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
            
class ZwischengroesseElement(CanvasElement):
    def __init__(self, zf, name, pos=(10,10)):
        '''zeichenflaeche und eindeutigen Namen uebergeben'''
        x,y,xe,ye=self.BestimmeKoordinaten(pos, name)
        ID=zf.create_oval(x,y, xe,ye, tag=name, outline='#600', width=2)
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
            
class WirkungElement(CanvasElement):
    def __init__(self, zf, von, auf, bogenOrientierung=1):
        '''zeichenflaeche und eindeutige Namen uebergeben'''
        self.orBog=bogenOrientierung # Orientierung des Pfeilbogens
        self.von,self.auf=von, auf
        x,y=self.Mitte(zf.bbox(von))
        xe,ye=self.Mitte(zf.bbox(auf))
        if abs(y-ye)<10:
            if x>xe: verY=-self.orBog*10
            else: verY=self.orBog*10
            y,ye=y+verY,ye+verY
        xm,ym=self.Mitte((x,y,xe,ye))
        x,y = x+0.2*(xm-x),y+0.2*(ym-y)## Ueberschneidung vermeiden
        xe,ye = xe+0.2*(xm-xe),ye+0.2*(ym-ye)
        self.ve=0.3 # VersatzFaktor fuer orthogonal       
        dx,dy=self.orBog*(1+int(self.ve*(ye-y))),self.orBog*(-1-int(self.ve*(xe-x)))
        ID=zf.create_line(x,y,xm-dx,ym-dy,xe,ye,
                          arrow=LAST, smooth=True, width=2, tag=von+'->'+auf)
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), None)
        CanvasElement.NeuesElement(von+'->'+auf,self)
        
    def GibBogenOrientierung(self): return self.orBog
        
class FlussElement(CanvasElement):
    def __init__(self, zf, name, von, auf):
        '''zeichenflaeche und eindeutige Namen uebergeben'''
        ### Unterscheidung von ist '' oder auf ist '' notwendig:
        self.von,self.auf=von, auf
        if von=='': von="Quelle"
        elif auf=='': auf="Senke"
        if von!="Quelle":
            x,y=self.Mitte(zf.bbox(von))
            x=zf.bbox(von)[2]
        if auf!="Senke":
            xe,ye=self.Mitte(zf.bbox(auf))
            xe=zf.bbox(auf)[0]
        if von=="Quelle":
            x0,y0,x1,y1=zf.bbox(auf)
            b=max(40,len(name)*11)
            x,y=x0-20-b,(y0+y1)/2
            xe,ye=x0,(y0+y1)/2
            self.quelleSenke=QuelleSenke(zf,name,x,y,"Quelle")
        elif auf=="Senke":
            x0,y0,x1,y1=zf.bbox(von)
            b=max(40,len(name)*11)
            x,y=x1,(y0+y1)/2
            xe,ye=x1+20+b,(y0+y1)/2
            self.quelleSenke=QuelleSenke(zf,name,xe,ye,"Senke")
        ID=zf.create_line(x,y,xe,ye,
                          width=5,
                          arrowshape=(10,20,5),
                          dash=(15,5),
                          arrow=LAST,
                          tag=name)
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        
    def GibVonAuf(self):
        return self.von,self.auf
    
    def UpdateNamen(self, von, auf):
        self.von,self.auf=von, auf
        
class QuelleSenke(CanvasElement):
    def __init__(self,zf, name,x,y,was):
        '''Quelle oder Senke sind an einen Fluss gebunden'''
        if was=="Senke":
            ID=zf.create_polygon(x-5,y-5,
                                 x+15,y-5,
                                 x+12,y+15,
                                 x-2,y+15,
                                 fill='#888',
                                 tag=name)
            CanvasElement.__init__(self, zf, ID, (x-5,y-5), (x+15,y+15))
        else:
            ID=zf.create_polygon(x-12,y-15,
                                 x+2,y-15,
                                 x+5,y+5,
                                 x-15,y+5,
                                 fill='#888',
                                 tag=name)
            CanvasElement.__init__(self, zf, ID, (x-15,y-15), (x+5,y+5))
