#!/usr/bin/env python
# -*- coding: utf-8 -*-
# simu_test.py
# © Claus Albowski

from simulation import *

#### Tests:
## Test 1 alles mit Aenderungen
##simu=Simulation.GibSimulation()
##simu.NeuerBestandsfaktor('x',3.0)
##simu.NeuerFluss('dx','','x')
##simu.NeuerBestandsfaktor('v', 0.0)
##simu.NeuerFluss('dv','','v')
##simu.NeuerParameter('D', 1.5)
##simu.NeuerParameter('M', 0.8)
##simu.NeueZwischengroesse('a')
##simu.NeueWirkung('x','a')
##simu.NeueWirkung('D','a')
##simu.NeueWirkung('M','a')
##simu.NeueWirkung('a','dv')
##simu.NeueWirkung('v','dx')
##simu.SetzeTerm('dx','v()')
##simu.SetzeTerm('dv','a()')
##simu.SetzeTerm('a','-1.0*D()*x()/M()')
##simu.Setze_dt(1.0)
##simu.SichereModellDaten()
##simu.BerechneWerte(['t','x','v'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung(simu.GibAlleFaktorNamen())
##print()
##simu.AendereFaktorNamen('x','y')
##simu.BerechneWerte(['t','y','v'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung(simu.GibAlleFaktorNamen())
##print()
##simu.AendereFaktorNamen('dx','dy')
##simu.BerechneWerte(['t','y','v'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung(simu.GibAlleFaktorNamen())
##print()

## Test 2: Loeschen von Faktoren
#### 2a: Bestandsfaktor
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Bakterienwachstum.simdat')
##simu.Meldung('Faktoren', simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))
##simu.LoescheBestandsfaktor('Bakterien')
##simu.Meldung('Faktoren', simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))

## 2b: Fluss
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Bakterienwachstum.simdat')
##simu.Meldung('Faktoren', simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))
##simu.LoescheFluss('Zuwachs_B')
##simu.Meldung('Faktoren', simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))

## 2c: Parameter
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Kaffeetasse_3.simdat')
##simu.Meldung('Faktoren', simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))
##simu.LoescheParameter('Umgebungstemperatur')
##simu.Meldung('Faktoren', simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))

## 2c2: Parameter mit Term
##simu=Simulation.GibSimulation()
##simu.NeuerBestandsfaktor('x',3.0)
##simu.NeuerFluss('dx','','x')
##simu.NeuerBestandsfaktor('v', 0.0)
##simu.NeuerFluss('dv','','v')
##from math import sin,pi
##simu.NeuerParameter('F', 'sin(t()/10.0*2*pi)')
##simu.NeuerParameter('M', 0.8)
##simu.NeueZwischengroesse('a')
##simu.NeueWirkung('F','a')
##simu.NeueWirkung('M','a')
##simu.NeueWirkung('a','dv')
##simu.NeueWirkung('v','dx')
##simu.SetzeTerm('dx','v()')
##simu.SetzeTerm('dv','a()')
##simu.SetzeTerm('a','F()/M()')
##simu.Setze_dt(1.0)
##simu.SichereModellDaten()
##simu.BerechneWerte(['t','x','v'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung(simu.GibAlleFaktorNamen())

## 2c3: Parameter mit Term lesen und schreiben
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/ErzwungeneSchwingung.simdat')
##simu.Meldung('Parameter mit Term lesen und schreiben')
##simu.SetzeAnzahlSchritte(30)
##simu.BerechneWerte(['t','x','v','Anregung'])
##simu.Meldung(simu.GibWerte())
##simu.Speichere('Modelle/ErzwungeneSchwingung.simdat')

## 2d: Zwischengroesse
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Kaffeetasse_3.simdat')
##simu.Meldung(['Faktoren: ']+ simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))
##simu.LoescheZwischengroesse('T_Differenz')
##simu.Meldung(['Faktoren: ']+ simu.GibAlleFaktorNamen())
##simu.Meldung('Wirkungen')
##for wirkung in simu.GibWirkungen():
##    simu.Meldung((wirkung.GibVon()+' -> '+wirkung.GibAuf()))

## Test 3: Lesen und Schreiben
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Bakterienwachstum.simdat')
##simu.Setze_dt(1.0)
##simu.SichereModellDaten()
##simu.BerechneWerte(['t','Bakterien'])
##simu.Meldung(simu.GibWerte())

## Test 4: Lesen und Schreiben mit Aendern
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Feder.simdat')
##simu.Setze_dt(1.0)
##simu.SichereModellDaten()
##simu.BerechneWerte(['t','Auslenkung'])
##simu.Meldung(simu.GibWerte())
##simu.AendereFaktorNamen('Auslenkung','x')
##simu.BerechneWerte(['t','x'])
##simu.Meldung(simu.GibWerte())
##simu.Speichere('Modelle/Feder_bearbeitet.simdat')

## Test 5: Einfaches Eulerverfahren
##simu=Simulation.GibSimulation()
##simu.SetzeSimulationsMethode('einfach Euler')
##simu.Setze_dt(1.0)
##simu.NeuerBestandsfaktor('Kapital',1000.0)
##simu.NeuerFluss('Zinsen','','Kapital')
##simu.NeuerParameter('Zinssatz', 1.5)
##simu.NeueWirkung('Zinssatz','Zinsen')
##simu.NeueWirkung('Kapital','Zinsen')
##simu.SetzeTerm('Zinsen','Zinssatz()*Kapital()/100.0')
##simu.BerechneWerte(['t','Kapital'])
##simu.Meldung(simu.GibWerte())

## Test 6: Einfaches Eulerverfahren
##simu=Simulation.GibSimulation()
##simu.SetzeSimulationsMethode('Runge-Kutta')#('erweitert Euler')#
##simu.Setze_dt(1.0)
##simu.NeuerBestandsfaktor('Kaninchen',1000)
##simu.NeuerFluss('Geburten','','Kaninchen')
##simu.NeuerParameter('Saettigung', 20000)
##simu.NeuerParameter('Geburtenrate', 0.2)
##simu.NeueWirkung('Saettigung','Geburten')
##simu.NeueWirkung('Geburtenrate','Geburten')
##simu.NeueWirkung('Kaninchen','Geburten')
##simu.SetzeTerm('Geburten','Geburtenrate()*Kaninchen()*(Saettigung()-Kaninchen())/Saettigung()')
##simu.BerechneWerte(['t','Kaninchen'])
##simu.Meldung(simu.GibWerte())

## Test 7: Lesen und Verzoegerung einbauen 
##simu.Meldung("--ohne Verzoegerung--")
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Bakterienwachstum.simdat')
##simu.SetzeTerm('Zuwachs_B','0.3*Bakterien()')
##simu.BerechneWerte(['t','Bakterien'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung("--mit Verzoegerung--")
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Bakterienwachstum.simdat')
##simu.SetzeTerm('Zuwachs_B','0.3*Bakterien(alterWert,3)')
##simu.BerechneWerte(['t','Bakterien'])
##simu.Meldung(simu.GibWerte())

## Test 8:
#### Test zu Tabelle in Parameter vorgeben
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Bakterienwachstum_mit_Rate.simdia')
##simu.BerechneWerte(['t','Bakterien','Rate'])
##simu.Meldung(simu.GibWerte())
##Rate=Faktor.FaktorZuNamen('Rate')
##Rate.NeuesTabellenPaar((0.0,0.2))
##Rate.NeuesTabellenPaar((4.0,0.4))
##simu.BerechneWerte(['t','Bakterien','Rate'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung(Rate.GibTabellenWerte())
##simu.Meldung(Rate.GibAlleWerte())
##print()
##Rate.NeuesTabellenPaar((6.0,0.9))
##simu.BerechneWerte(['t','Bakterien','Rate'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung(Rate.GibTabellenWerte())
##simu.Meldung(Rate.GibAlleWerte())

## Test 9:
##### Tests zur Verzoegerung:
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/Bakterienwachstum-mit-altemWert.simdia')
##simu.Meldung(' Einfach')
##simu.BerechneWerteEinfach(['t','Bakterien'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung('\n Erweitert')
##simu.BerechneWerteErweitert(['t','Bakterien'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung('\n RungeKutta')
##simu.BerechneWerteRungeKutta(['t','Bakterien'])
##simu.Meldung(simu.GibWerte())
##simu.Meldung(u'\n Term ändern')
##Faktor.FaktorZuNamen('Zuwachs_B').SetzeTerm('0.3*Bakterien()')
##simu.BerechneWerteErweitert(['t','Bakterien'])
##simu.Meldung(simu.GibWerte())

## Test 10:
##### Tests zu Neues Modell:
##simu=Simulation.GibSimulation()
##simu.Lies('Modelle/ErzwungeneSchwingung.simdia')
##print(Faktor.GibAlleFaktorNamen())
##simu.Meldung(' Tests zu Neues Modell')
##simu.LoescheAktuellesModell()
##print(Faktor.GibAlleFaktorNamen())

## Test 11:
#### Korrektur Setze-Term testen
simu=Simulation.GibSimulation()
name='x'
simu.NeuerBestandsfaktor(name, 3.0)
name='a'
zg=simu.NeueZwischengroesse(name)
zg.SetzeTerm('x()')
simu.NeueWirkung('x', 'a')
name='v'
fl=simu.NeuerFluss(name, '', 'x')
fl.SetzeTerm('a()')
simu.NeueWirkung('a', 'v')
simu.SichereModellDaten()
simu.Meldung(simu.ZeigeModellDaten())
print(simu.GibFaktorNamen('Fluss'))
print(simu.GibFaktorNamen('Zwischengroesse'))
simu.BerechneWerteErweitert(['x','v','a'])
simu.Meldung(simu.GibWerte())
simu.SetzeTerm('a','x()*1.1')
simu.SichereModellDaten()
simu.Meldung(simu.ZeigeModellDaten())
print(simu.GibFaktorNamen('Fluss'))
print(simu.GibFaktorNamen('Zwischengroesse'))
simu.BerechneWerteErweitert(['x','v','a'])
simu.Meldung(simu.GibWerte())
