# term.py

#### Hilfsfunktionen:
def letzter(wort):
    '''wort muss mindestens ein Zeichen enthalten'''
    return wort[len(wort)-1]

def holeBuchstaben(wort):
    '''spaltet am ersten Zeichen, das kein Buchstabe ist'''
    if wort.isalpha(): return (wort,'')
    if not(wort[0].isalpha()): return ('',wort)
    spaltPosition=0
    for i in range(len(wort)):
        if not(wort[i].isalpha()):
            if spaltPosition==0:
                spaltPosition=i+1
    return (wort[0:spaltPosition-1],wort[spaltPosition-1:])

def UpdateTerm(term, alt, neu):
    '''Passt den Term an einen geaenderten Faktornamen an.'''
    if term.find(alt)>-1:
        vorn, mitte, hinten=term.partition(alt)
        if len(vorn)>0:
            if letzter(vorn).isalpha():
                # alt ist nur Teil der Buchstabenkette,
                # nicht bearbeiten, aber nach dem
                # Ende der Buchstaben weiter suchen
                return vorn+mitte+UpdateTerm(hinten, alt, neu)
        if len(hinten)>1:
            if hinten[0:2]!='()':
                # hinter Faktornamen muss () folgen, kann aber noch kommen
                hi1,hi2=holeBuchstaben(hinten)
                return vorn+mitte+hi1+UpdateTerm(hi2, alt, neu)
        ## hinter weiter ersetzen
        return vorn+neu+UpdateTerm(hinten, alt, neu)
    else:
        return term

def string_in_Zahl(ZahlString):
    '''Die Funktion bestimmt zu einem Zahlstring den Zahlenwert
    und gibt im Misserfolgsfall 0.0 zurueck.'''
    try:
        wert=float(ZahlString)
    except Exception:
        wert=0.0
    return wert

##term='-dx()*x()+3*xq()-xxx()'
##print term
##term=UpdateTerm(term, 'x','y')
##print term


